# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _with_repolib 1

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/facelets/1.1.14.patch01-brew
%define repodirlib %{repodir}/lib
%define repodirres %{repodir}/resources
%define repodirsrc %{repodir}/src

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section       free

Name:           facelets
Version:        1.1.14
Release:        2.5%{?dist}
Epoch:          0
Summary:        JavaServer Faces View Definition Framework
License:        ASL 2.0
Source0:        facelets-%{version}.tar.gz
# cvs -d :pserver:guest@cvs.dev.java.net:/cvs login
# cvs -d :pserver:guest@cvs.dev.java.net:/cvs export -r milestone_1-1-14 facelets 
Source1:	facelets-component-info.xml
URL:            https://facelets.dev.java.net/
Group:          Development/Libraries/Java
# Fix for JBPAPP-1900, JPBTP-1: composite components refresh problem
# REVERT: https://facelets.dev.java.net/issues/show_bug.cgi?id=336
Patch1:		facelets-issue#336.patch

%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%else
BuildArch:      noarch
BuildRequires:  java-devel >= 0:1.5
%endif

BuildRequires:  ant
BuildRequires:  jpackage-utils
#BuildRequires: el_1_0_api
BuildRequires:  tomcat6-el-1.0-api 
#BuildRequires: tomcat6-lib
BuildRequires:  el-impl
#BuildRequires: jsf_1_2_api
BuildRequires:  glassfish-jsf
#BuildRequires: servlet_2_4_api
BuildRequires:  servletapi5

Requires(post):    jpackage-utils >= 0:1.7.3
Requires(postun):  jpackage-utils >= 0:1.7.3

#Requires:  el_1_0_api
#Requires:  tomcat6-lib
#Optional:  el-impl
#Requires:  jsf_1_2_api
Requires:  glassfish-jsf
#Requires:  servlet_2_4_api
#Requires:  servletapi5

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
The web community is eagerly seeking a framework like 
Tapestry, backed by JavaServer Faces as the industry 
standard. While JavaServer Faces and JSP are meant to 
be aligned,Facelets steps outside of the JSP spec and 
provides a highly performant, JSF-centric view technology. 
Anyone who has created a JSP page will be able to do the 
same with Facelets. The difference is under the hood where 
all the burden of the JSP Vendor API is removed to more 
greatly enhance JSF performance and provide easy plug-and-go 
development. Even though Facelets is being developed open 
source under Sun's guidance, it can work with any JSF 1.2 
compliant implementation or MyFaces. 

Container or classpath must have: Servlet 2.4, JSF 1.2  and EL 1.0

%if %{with_repolib}
%package	 repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	Development/Libraries/Java

%description	 repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%package manual

Summary:        Manual for %{name}
Group:          Development/Java

%description manual
%{summary}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n %{name}
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done

mkdir lib
#ln -sf $(build-classpath jsf_1_2_api) lib/jsf-api-1.2_04-p02.jar
ln -sf $(build-classpath glassfish-jsf-api) lib/jsf-api-1.2_04-p02.jar
#ln -sf $(build-classpath servlet_2_4_api) lib/servlet-api-2.4.jar
ln -sf $(build-classpath servletapi5) lib/servlet-api-2.4.jar
#ln -sf $(build-classpath el_1_0_api) lib/el-api-1.0.jar
ln -sf $(build-classpath tomcat6-el-1.0-api) lib/el-api-1.0.jar
ln -sf $(build-classpath el-impl) lib/el-impl-1.0.jar

# We are actually reverting this upstream change
%patch1 -R

tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE1}

%build
export CLASSPATH=
export OPT_JAR_LIST=:
%{ant} 

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -a dist/jsf-facelets.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do %{__ln_s} ${jar} `echo $jar| %{__sed} "s|-%{version}||g"`; done)
# Keep also upstream JAR name as a symlink
(cd %{buildroot}%{_javadir} && %{__ln_s} %{name}-%{version}.jar jsf-facelets.jar)

# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
sed -i -e 's/@VERSION@/%{version}/' jsf-%{name}.pom
%{__cp} -a jsf-%{name}.pom $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap com.sun.facelets jsf-%{name} %{version} JPP %{name}

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -a build/docs/api/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif


%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{PATCH1} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	cp $RPM_BUILD_ROOT%{_javadir}/facelets.jar $RPM_BUILD_ROOT%{repodirlib}/jsf-facelets.jar
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%{_javadir}/*.jar
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/*
%endif
%{_datadir}/maven2/*
%{_mavendepmapfragdir}/*

%files manual
%defattr(0644,root,root,0755)
%if 0
%doc build/%{name}%{archive_version}/docs/*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}


%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif

%changelog
* Wed Apr 22 2009 Fernando Nasser <fnasser@redhat.com> 0:1.1.14-2.5
- Build repolib subpackage

* Wed Apr 22 2009 Fernando Nasser <fnasser@redhat.com> 0:1.1.14-2.4
- Add repolib subpackage

* Wed Apr 22 2009 Fernando Nasser <fnasser@redhat.com> 0:1.1.14-2.3
- Properly describe things needed in the classpath and not explicitly required
  From Marek Novotnik <mnovotnik@redhat.com>:
- Fix for JBPAPP-1900, JPBTP-1: composite components refresh problem

* Tue Apr 21 2009 Martha Benitez <mbenitez@redhat.com> 0:1.1.14-2.2
- Change Requires: el-impl to Optional

* Fri Apr 17 2009 David Walluck <dwalluck@redhat.com> 0:1.1.14-2.1
- remove Requires: servletapi5
- remove Requires: tomcat6-lib

* Tue Jan 20 2009 Ralph Apel <r.apel@r-apel.de> 0:1.1.14-2
- Fix depmap frag 

* Thu Dec 18 2008 Ralph Apel <r.apel@r-apel.de> 0:1.1.14-1
- First release

